SystemOrganization addCategory: #'Pier-Documentation'!

!String methodsFor: '*pier-documentation' stamp: 'lr 5/22/2006 16:45'!
hyphenate
	^ String streamContents: [ :stream |
		stream nextPut: self first.
		self reduce: [ :a :b |
			(a isLowercase and: [ b isUppercase ])
				ifTrue: [ stream nextPutAll: '\-' ].
			stream nextPut: b ] ]! !

PRVisitor subclass: #PRLatexWriter
	instanceVariableNames: 'stream offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Documentation'!

!PRLatexWriter class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:29'!
format: aDocument offset: anInteger on: aStream
	^ self new
		setOffset: anInteger;
		setStream: aStream;
		visit: aDocument;
		contents! !

!PRLatexWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
contents
	^ self stream contents! !

!PRLatexWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
offset
	^ offset! !

!PRLatexWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:29'!
sectionForLevel: anInteger
	^ #( 'part' 'chapter' 'section' 'subsection' 'subsubsection' 'paragraph' )
			at: self offset + anInteger ifAbsent: 'subparagraph'! !

!PRLatexWriter methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setOffset: anInteger
	offset := anInteger! !

!PRLatexWriter methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setStream: aStream
	stream := aStream! !

!PRLatexWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
stream
	^ stream! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitAnchor: anObject
	self stream tag: 'label'; curly: anObject name; cr! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 4/10/2007 20:50'!
visitBoldFormat: anObject
	self stream tag: 'textbf'; curly: [ super visitBoldFormat: anObject ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitExternalLink: anObject
	self stream
		tag: 'href';
		curly: [ self stream basicPutAll: anObject url ];
		curly: [ super visitExternalLink: anObject ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitHeader: anObject
	self stream tag: (self sectionForLevel: anObject level); curly: anObject text; cr! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 4/10/2007 20:51'!
visitInternalLink: anObject
	self stream
		tag: 'hyperref';
		square: [ self stream basicPutAll: anObject reference ];
		curly: [ super visitInternalLink: anObject ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 4/10/2007 20:52'!
visitItalicFormat: anObject
	self stream tag: 'textit'; curly: [ super visitItalicFormat: anObject ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitLink: anObject
	anObject hasChildren
		ifTrue: [ super visitLink: anObject ]
		ifFalse: [ self stream print: anObject reference ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitListItem: anObject
	self stream tag: 'item'; space.
	super visitListItem: anObject.
	self stream cr! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 4/10/2007 20:52'!
visitMonospaceFormat: anObject
	self stream tag: 'texttt'; curly: [ super visitMonospaceFormat: anObject ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitOrderedList: anObject
	self stream environment: 'enumerate' do: [ super visitOrderedList: anObject ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitParagraph: anObject
	super visitParagraph: anObject.
	self stream cr; cr! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitPreformatted: anObject
	self stream environment: 'source' do: [
		anObject children do: [ :each |
			self stream basicPutAll: each text; cr ] ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitTable: anObject
	self stream environment: 'tabular' do: [
		self stream curly: (String new: anObject columnCount withAll: $l); cr.
		self visitAll: anObject children separatedBy: [ self stream basicPutAll: '\\'; cr ] ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitTableRow: aTableRow
	self visitAll: aTableRow children separatedBy: [ self stream basicPut: $& ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 4/10/2007 21:55'!
visitText: anObject
	self stream nextPutAll: anObject text! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitUnorderedList: anObject
	self stream environment: 'itemize' do: [ super visitUnorderedList: anObject ]! !

!Object methodsFor: '*pier-documentation-printing' stamp: 'lr 3/9/2006 11:29'!
printLatexOn: aStream
	aStream nextPutAll: self displayString! !

Object subclass: #PRLatexBuilder
	instanceVariableNames: 'package directory name stream classes categories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Documentation'!

!PRLatexBuilder class methodsFor: 'building' stamp: 'lr 4/10/2007 21:55'!
build
	"The default build script for my master."

	self
		build: (PackageInfo named: 'Magritte-Model')
		in: FileDirectory default named: 'magritte.tex'.
	self
		build: (PackageInfo named: 'Pier-Model')
		in: FileDirectory default named: 'pier.tex'! !

!PRLatexBuilder class methodsFor: 'building' stamp: 'lr 5/28/2006 17:53'!
build: aPackage in: aDirectory named: aString
	^ self new
		setPackage: aPackage;
		setDirectory: aDirectory;
		setName: aString;
		build! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 5/28/2006 18:37'!
build
	| output |
	stream := PRLatexStream on: String new.
	classes := (self package classes select: [ :each | each hasComment ]) asSet.
	categories := (classes collect: [ :each | each category ]) asSet.
	self package systemCategories
		do: [ :each |
			(categories includes: each)
				ifTrue: [ self buildCategory: each ] ]
		displayingProgress: self package packageName.
	output := self directory forceNewFileNamed: self name.
	[ output nextPutAll: stream contents ] ensure: [ output close ]! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 5/29/2006 09:55'!
buildCategory: aSymbol
	stream
		tag: 'phantomsection'; cr;
		tag: 'addcontentsline'; curly: 'toc'; curly: 'section'; curly: aSymbol; cr;
		tag: 'section*'; curly: [
			stream
				print: aSymbol;
				tag: 'label'; curly: aSymbol ];
		cr; cr.
	((classes
		select: [ :each | each category = aSymbol ])
		asSortedCollection: [ :a :b | a name <= b name ])
		do: [ :each | self buildClass: each ]! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 5/29/2006 09:56'!
buildClass: aClass 
	stream 
		tag: 'phantomsection'; cr;
		tag: 'addcontentsline'; curly: 'toc'; curly: 'subsection'; curly: aClass name; cr;
		tag: 'subsection*'; curly: [
			stream
				print: aClass name;
				tag: 'label'; curly: aClass name;
				tag: 'index'; curly: (aClass name allButFirst: 2) ];
		cr; cr.
	self
		buildClassEnum: aClass allSuperclasses allButLast reverse
		labelled: 'Superclasses' on: stream.
	self
		buildClassEnum: ((aClass allSubclasses
			select: [ :each | classes includes: each ])
			asSortedCollection: [ :a :b | a name <= b name ])
		labelled: 'Subclasses' on: stream.
	self wiki: aClass organization classComment offset: 4.
	(self package coreCategoriesForClass: aClass) asSortedCollection
		do: [ :each | self buildClass: aClass category: each ]! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 4/10/2007 20:57'!
buildClass: aClass category: aString
	(Categorizer allCategory = aString
		or: [ Categorizer nullCategory = aString ]
		or: [ aString beginsWith: 'private' ])
			ifTrue: [ ^ self ].
	((aClass organization listAtCategoryNamed: aString)
		allSatisfy: [ :each | (aClass firstPrecodeCommentFor: each) isEmptyOrNil ])
			ifTrue: [ ^ self ].
	stream tag: 'subsubsection*'; curly: aString; cr.
	stream environment: 'itemize' do: [
		(aClass organization listAtCategoryNamed: aString) asSortedCollection
			do: [ :each | self buildClass: aClass category: aString selector: each ] ].
	stream cr; cr
! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 5/29/2006 12:08'!
buildClass: aClass category: aString selector: aSelector
	| source |
	source := aClass firstPrecodeCommentFor: aSelector.
	source isEmptyOrNil ifTrue: [ ^ self ].
	stream 
		tag: 'item'; 
		tag: 'index'; curly: aSelector;
		tag: 'code'; curly: [ stream nextPutClose: (aClass methodHeaderFor: aSelector) ];
		basicPutAll: ' \\'; cr.
	self wiki: source offset: 5.
	stream cr! !

!PRLatexBuilder methodsFor: 'building-tools' stamp: 'lr 5/29/2006 10:00'!
buildClassEnum: aCollection labelled: aString on: aStream
	aCollection isEmpty ifTrue: [ ^ self ].
	aStream environment: 'sloppypar' do: [
		aStream tag: 'paragraph'; curly: aString; cr.
		aCollection
			do: [ :each |
				aStream tag: 'code'; curly: [
					(classes includes: each)
						ifFalse: [ aStream basicPutAll: each name hyphenate ]
						ifTrue: [ 
							aStream tag: 'hyperref'; square: each name; curly: [
							aStream basicPutAll: each name hyphenate ] ] ] ]
			separatedBy: [ aStream nextPutAll: ', ' ].
		aStream cr ].
	aStream cr; cr! !

!PRLatexBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
directory
	^ directory! !

!PRLatexBuilder methodsFor: 'accessing' stamp: 'lr 5/22/2006 08:06'!
name
	^ name! !

!PRLatexBuilder methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:54'!
package
	^ package! !

!PRLatexBuilder methodsFor: 'initialization' stamp: 'lr 5/5/2006 18:30'!
setDirectory: aDirectory
	directory := aDirectory assureExistence! !

!PRLatexBuilder methodsFor: 'initialization' stamp: 'lr 5/22/2006 08:05'!
setName: aString
	name := aString! !

!PRLatexBuilder methodsFor: 'initialization' stamp: 'lr 5/28/2006 17:55'!
setPackage: aPackage
	package := aPackage! !

!PRLatexBuilder methodsFor: 'private' stamp: 'lr 5/22/2006 09:11'!
wiki: aString offset: anInteger
	PRLatexWriter
		format: (PRDocumentParser parse: (aString ifNil: [ String new ]))
		offset: anInteger on: stream.
	stream cr; cr! !

ReadWriteStream subclass: #PRLatexStream
	instanceVariableNames: ''
	classVariableNames: 'LatexCharacters'
	poolDictionaries: ''
	category: 'Pier-Documentation'!

!PRLatexStream class methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
initialize
	LatexCharacters := Dictionary new.
	LatexCharacters
		at: $# put: '\#';
		at: $& put: '\&';
		at: $% put: '\%';
		at: $$ put: '\$';
		at: ${ put: '\{';
		at: $} put: '\}';
		at: $" put: '\symbol{34}';
		" -- "
		at: $[ put: '{[}';
		at: $] put: '{]}';
		at: $| put: '$|$';
		at: $< put: '$<$';
		at: $> put: '$>$';
		at: $/ put: '$/$';
		at: $\ put: '$\backslash$';
		at: $_ put: '$\leftarrow$';
		at: $^ put: '$\uparrow$';
		" -- "
		at: $ put: '\"{a}';
		at: $ put: '\"{A}';
		at: $ put: '\"{e}';
		at: $ put: '\"{E}';
		at: $ put: '\"{i}';
		at: $ put: '\"{I}';
		at: $ put: '\"{o}';
		at: $ put: '\"{O}';
		at: $ put: '\"{u}';
		at: $ put: '\"{U}';
		at: $ put: '\"{y}';
		at: $ put: '\"{Y}';
		" -- "
		at: $ put: '\^{a}';
		at: $ put: '\^{A}';
		at: $ put: '\^{e}';
		at: $ put: '\^{E}';
		at: $ put: '\^{i}';
		at: $ put: '\^{I}';
		at: $ put: '\^{o}';
		at: $ put: '\^{O}';
		at: $ put: '\^{u}';
		at: $ put: '\^{U}';
		" -- "
		at: $ put: '\`{a}';
		at: $ put: '\`{A}';
		at: $ put: '\`{e}';
		at: $ put: '\`{E}';
		at: $ put: '\`{i}';
		at: $ put: '\`{I}';
		at: $ put: '\`{o}';
		at: $ put: '\`{O}';
		at: $ put: '\`{u}';
		at: $ put: '\`{U}';
		" -- "
		at: $ put: '\''{a}';
		at: $ put: '\''{A}';
		at: $ put: '\''{e}';
		at: $ put: '\''{i}';
		at: $ put: '\''{I}';
		at: $ put: '\''{o}';
		at: $ put: '\''{O}';
		at: $ put: '\''{u}';
		at: $ put: '\''{U}';
		" -- "
		at: $ put: '\c{c}';
		at: $ put: '\c{C}';
		" -- "
		at: $~ put: '\~{}';
		at: $ put: '\~{n}';
		at: $ put: '\~{N}'! !

!PRLatexStream methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
basicPut: aCharacter
	super nextPut: aCharacter! !

!PRLatexStream methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
basicPutAll: aString
	super nextPutAll: aString! !

!PRLatexStream methodsFor: 'conveniance' stamp: 'lr 3/9/2006 11:29'!
comment: anObject
	self basicPut: $%; space; basicPutAll: anObject asString; cr! !

!PRLatexStream methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:29'!
cr
	(position isZero
		or: [ position > 1
		and: [ (collection at: position) = Character cr
		and: [ (collection at: position - 1) = Character cr ] ] ])
			ifTrue: [ ^ self ].
	super cr! !

!PRLatexStream methodsFor: 'conveniance' stamp: 'lr 3/9/2006 11:29'!
curly: anObject
	self basicPut: ${; print: anObject; basicPut: $}! !

!PRLatexStream methodsFor: 'conveniance' stamp: 'lr 3/9/2006 11:29'!
environment: aString do: anObject
	self tag: 'begin'; curly: aString; cr.
	self print: anObject.
	self tag: 'end'; curly: aString; cr! !

!PRLatexStream methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:29'!
nextPut: aCharacter
	| string |
	string := LatexCharacters at: aCharacter ifAbsent: nil.
	string isNil
		ifTrue: [ self basicPut: aCharacter ]
		ifFalse: [ self basicPutAll: string ]! !

!PRLatexStream methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:29'!
nextPutAll: anObject
	anObject asString do: [ :each | self nextPut: each ]! !

!PRLatexStream methodsFor: 'streaming' stamp: 'lr 5/17/2006 14:59'!
nextPutClose: anObject
	anObject asString do: [ :each | 
		Character space = each
			ifTrue: [ self basicPut: $~ ]
			ifFalse: [ self nextPut: each ] ]! !

!PRLatexStream methodsFor: 'initialization' stamp: 'lr 5/17/2006 13:59'!
on: aCollection
	super on: aCollection.
	self
		comment: '$Id:$';
		comment: SystemVersion current asString;
		comment: TimeStamp now asString;
		cr;
		comment: 'This is an automatically generated file, do not modify manually!!';
		cr;
		cr! !

!PRLatexStream methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:29'!
print: anObject
	anObject printLatexOn: self! !

!PRLatexStream methodsFor: 'conveniance' stamp: 'lr 3/9/2006 11:29'!
square: anObject
	self basicPut: $[; print: anObject; basicPut: $]! !

!PRLatexStream methodsFor: 'conveniance' stamp: 'lr 3/9/2006 11:29'!
tag: aString
	self basicPut: $\; basicPutAll: aString! !

!UndefinedObject methodsFor: '*pier-documentation-printing' stamp: 'lr 3/9/2006 11:29'!
printLatexOn: aStream! !

!BlockContext methodsFor: '*pier-documentation-printing' stamp: 'lr 3/9/2006 11:29'!
printLatexOn: aStream
	self numArgs = 0
		ifTrue: [ self value ]
		ifFalse: [ self value: aStream ]! !
PRLatexStream initialize!
